export interface UkeLangStruct {
    [lang: string]: {
        [translateKey: string]: string;
    };
}
export interface UkelliUIConfig {
    iconMapper: {};
    iconPrefix: (str: string) => string;
}
declare const ukelliui: UkelliUIConfig;
/**
 * 内部翻译接口
 * @param {string} key 需要翻译的内容
 */
declare const $T_UKE: (key: any) => string;
/**
 * 外部内容翻译接口
 * @param {string} key 需要翻译的内容
 */
declare const $T: (key: any) => string;
declare function setUkeLang(lang: string): void;
/**
 * 设置 uke 内部语言配置
 * @param {UkeLangStruct} config
 */
declare function setUkeLangConfig(config: UkeLangStruct): void;
/**
 * 设置外部翻译数据
 * @param {object} nextTranslate 翻译的内容
 */
declare function setLangTranslate(nextTranslate: any): void;
/**
 * 设置 ukelli ui 配置
 * @param {ukelliui} config ukelli ui 的配置
 */
declare function setUkelliConfig(config: typeof ukelliui): UkelliUIConfig;
/**
 * 获取 ukelli ui 配置
 * @param {string} configKey 配置的 key
 */
declare function getUkelliConfig(configKey: string): any;
/**
 * 合并参数，返回 icon 的 className
 * @param {string} iconName icon 对应的名字
 * @param {string}  iconStyle 对应的 style
 * @param {string[] | string} mergeClassNames 需要合并的 classNames
 * @param {boolean} useIconConfig 是否使用内置的配置
 */
declare function getIcon(iconName: any, iconStyle: any, mergeClassNames: any, useIconConfig?: boolean): any;
export { $T, $T_UKE, getUkelliConfig, setUkelliConfig, getIcon, setUkeLang, setUkeLangConfig, setLangTranslate, };
