/// <reference types="react" />
import { DateBasic, DateBasicProps } from '../date-basic';
export interface DateShortcutProps extends DateBasicProps {
    /** 点击快捷方式的回调 */
    onClick?: (res: any) => void;
    /** onChange */
    onChange: DateBasicProps['onChange'];
    /** 默认的时分秒的值 */
    defaultTimes?: string[];
    /** 自定义的时间快捷选项 */
    dateHelperInfo?: {
        t: string;
        filter: (args: any) => string[];
    }[];
    /** subContent 的位置 */
    position: 'right' | 'left';
    /** DateShortcut 的 style */
    style: {};
}
/**
 * 独立的快捷时间选择器
 *
 * @export
 * @class DateShortcut
 * @extends {DateBasic}
 */
export default class DateShortcut extends DateBasic<DateShortcutProps, {
    activeIdx: number;
}> {
    static defaultProps: {
        needTime: boolean;
        toUTC: boolean;
        position: string;
        outputAsString: boolean;
        defaultTimes: string[];
    };
    defaultDateHelperInfo: any;
    value: {};
    constructor(props: any);
    generateDate(itemConfig: any, idx: any): void;
    render(): JSX.Element;
}
