import React, { Component } from 'react';
export interface InputVerifyClassProps {
    onChange?: (value: any) => void;
    onFocus?: (val: any, focusEvent: any) => void;
    onBlur?: (blurEvent: any) => void;
    onClear?: () => void;
    className?: string;
    defaultValue?: any;
    value?: any;
    /** 限制输入数字的范围 */
    numRange?: [number, number];
    /** 限制输入的字符串长度范围 */
    lenRange?: [number, number, boolean];
}
interface State {
    value: any;
    matchLen: boolean;
    matchRange: boolean;
}
/**
 * 基础的输入框验证 class
 *
 * @export
 * @class InputVerifyClass
 * @extends {Component}
 */
export default class InputVerifyClass<P extends InputVerifyClassProps> extends Component<P, State> {
    isControl: any;
    isMatchLen: any;
    isPass: any;
    value: any;
    isMatchNumbRangeMode: any;
    constructor(props: any);
    checkProps(field: any): boolean;
    getValue(): any;
    _onChange(val: any, props?: Readonly<P> & Readonly<{
        children?: React.ReactNode;
    }>): void;
    _onFocus(val: any, event: any): void;
    _onBlur(e: any): void;
    onClear(): void;
    checkLen: (val: any, lenRange: any) => any;
    checkNum(val: any, numRange: any): number;
}
export {};
