import React from 'react';
import { UkeComponent } from '../utils/uke-component';
export declare type FormGeneratorTypes = 'customForm' | 'captcha' | 'select-n' | 'select' | 'input-selector-s' | 'input-selector' | 'input-range' | 'input' | 'password' | 'textarea' | 'ranger' | 'text' | 'radio' | 'checkbox' | 'button' | 'datetime' | 'datetimeRange' | 'switch' | 'hr';
export interface FormOptionsItem {
    /** UI 类型 */
    type: FormGeneratorTypes;
    /** 显示标题 */
    title?: string;
    /** className */
    className?: string;
    /** 是否必填|选 */
    required?: boolean;
    /** UI 的引用 key */
    ref?: string;
    /** UI 的引用 key, 作用于 datetime */
    refs?: string[];
    /** UI 的引用 key, 暂时弃用 */
    refu?: {
        [ref: string]: string;
    };
    [anyPropsForComponent: string]: any;
}
export declare type FormOptions = (FormOptionsItem | string)[];
export declare type FormChangeEvent = (formValues: any, changeRef: any, changeValue: any) => void;
export interface FormFilterProps<_FormOptions = FormOptions> {
    formOptions?: _FormOptions;
    conditionConfig?: _FormOptions;
    onChange?: FormChangeEvent;
}
/**
 * 表单生成器
 * 统一的聚合表单
 */
export default class FormFilterHelper<P extends FormFilterProps> extends UkeComponent<P> {
    _refs: {};
    state: {};
    value: {};
    requiredRefMapper: {};
    showDesc: any;
    __mount: boolean;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(prevProps: any, prevState: any): void;
    initValues(): void;
    resetValues(formOptions: any): void;
    getFormOptions(props?: Readonly<P> & Readonly<{
        children?: React.ReactNode;
    }>): P["formOptions"];
    checkFormOptions(prevProps: any): void;
    resetRequireRefMapper(nextProps?: Readonly<P> & Readonly<{
        children?: React.ReactNode;
    }>): void;
    setRequiredRefMapper(config: any): void;
    clearValue: () => void;
    _requiredMapperSetter: (ref: any, title: any) => void;
    setDefaultValues(options: any): void;
    setDefaultValue(config: any): void;
    checkForm(): {
        isPass: boolean;
        desc: string;
        ref: string;
    };
    wrapConditionTitle(config: any): any;
    focusRef(ref: any): void;
    /**
     * 改变单个值
     * @public
     * @param {any} value 目标改变的值的 value
     * @param {string} ref 改变的值的 ref
     * @param {boolean} update 是否更新视图
     */
    changeValue(value: any, ref: any, update?: boolean): void;
    /**
     * 改变多个值
     * @public
     * @param {object} valRefMapper 改变的值的 object
     * @param {boolean} update 是否更新视图
     */
    changeValues(valRefMapper: any, update?: boolean): void;
    refreshCaptcha(ref: any): void;
    zeroFilter: (target: any, otherwise?: any) => any;
    getValue(ref: any, otherwise?: any): any;
    saveRef: (ref: any) => (elem: any) => void;
    loadPlugin: (Plugin: any, props: any) => any;
    /** 获取 refs 的 ID */
    getRefsID: (refs: any) => string;
    /**
     * 表单插件接口
     *
     * @param {object} config 配置项
     * @memberof FormFilterHelper
     */
    getCustomForm: (config: any) => any;
    getCaptcha: (config: any) => JSX.Element;
    getSelectNative: (config: any) => JSX.Element;
    getSelect: (config: any) => JSX.Element;
    getInputSelectorS: (config: any) => JSX.Element;
    getInputSelector: (config: any) => JSX.Element;
    getInputRange: (config: any) => JSX.Element;
    getInput: (config: any) => JSX.Element;
    getTextArea: (config: any) => JSX.Element;
    getRange: (config: any) => JSX.Element;
    getText: (config: any) => JSX.Element;
    radioFactory: (Comp: any) => (config: any) => JSX.Element;
    getRadio: (config: any) => JSX.Element;
    getCheckbox: (config: any) => JSX.Element;
    getButton: (config: any) => JSX.Element;
    getDatetime: (config: any) => JSX.Element;
    changeDateValues: (vals: any, refs: any) => void;
    getDatetimeRange: (config: any) => JSX.Element;
    getSwitch: (config: any) => JSX.Element;
    getHr: () => JSX.Element;
    typeMapper: {
        customForm: (config: any) => any;
        captcha: (config: any) => JSX.Element;
        'select-n': (config: any) => JSX.Element;
        select: (config: any) => JSX.Element;
        'input-selector-s': (config: any) => JSX.Element;
        'input-selector': (config: any) => JSX.Element;
        'input-range': (config: any) => JSX.Element;
        input: (config: any) => JSX.Element;
        password: (config: any) => JSX.Element;
        textarea: (config: any) => JSX.Element;
        ranger: (config: any) => JSX.Element;
        text: (config: any) => JSX.Element;
        radio: (config: any) => JSX.Element;
        checkbox: (config: any) => JSX.Element;
        button: (config: any) => JSX.Element;
        datetime: (config: any) => JSX.Element;
        datetimeRange: (config: any) => JSX.Element;
        switch: (config: any) => JSX.Element;
        hr: () => JSX.Element;
    };
    greneratFormDOM(config: any): any;
}
