/// <reference types="react" />
import FormFilterHelper, { FormFilterProps, FormOptionsItem, FormChangeEvent } from './form-filter';
import { DivideType } from '../utils/props';
export declare type FormOptions = (FormOptionsItem | DivideType | string)[];
export interface FormGeneratorProps extends FormFilterProps<FormOptions> {
    /** 是否移动端，开启移动端渲染 */
    isMobile?: boolean;
    /** 表单的类型 */
    className?: string;
    /** 是否显示 input 组建的 title */
    showInputTitle?: boolean;
    /** 表单类型为 submit 时触发的回调 */
    onSubmit?: (formValue: any) => void;
    /** 内容改变 */
    onChange?: FormChangeEvent;
}
export default class FormGenerator extends FormFilterHelper<FormGeneratorProps> {
    static defaultProps: {
        onSubmit: () => void;
        className: string;
        isMobile: boolean;
    };
    ID: any;
    formItemRefs: {};
    constructor(props: any);
    showDesc: (checkRes: any) => void;
    render(): JSX.Element;
}
