export interface WindowItemConfig {
    title: string;
    isOpen: boolean;
    children: any;
    id: string;
}
export interface WindowMultipleState {
    minSecQueue: string[];
    sectionsQueue: string[];
    sectionsList: {
        [sectionID: string]: WindowItemConfig;
    };
}
declare const DefaultWindowManagerState: WindowMultipleState;
declare const windowManagerStore: import("unistore").Store<WindowMultipleState>;
declare const windowManagerActions: (store: any) => {
    closeAllWindow: () => void;
    closeWindow: ({ sectionsList, sectionsQueue, minSecQueue }: {
        sectionsList: any;
        sectionsQueue: any;
        minSecQueue: any;
    }, sectionId: any) => void;
    openWindow: ({ sectionsList, sectionsQueue, minSecQueue }: {
        sectionsList: any;
        sectionsQueue: any;
        minSecQueue: any;
    }, modalConfig: any) => void;
    selectWindow: ({ sectionsQueue, sectionsList, minSecQueue }: {
        sectionsQueue: any;
        sectionsList: any;
        minSecQueue: any;
    }, sectionId: any) => void;
    minimizeWindow: ({ minSecQueue, sectionsQueue, sectionsList }: {
        minSecQueue: any;
        sectionsQueue: any;
        sectionsList: any;
    }, sectionId: any) => void;
};
export { windowManagerActions, windowManagerStore, DefaultWindowManagerState };
