var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import React from 'react';
import ReactDOM from 'react-dom';
import { HasValue } from 'basic-helper';
import Notification from './notification';
import setDOMById from '../set-dom';
var notifyDOMId = 'NOTIFICATION_CONTAINER';
var notificationEntity;
/**
 * 将返回 config 的 id，用于消除该通知
 * @param {object} options
 */
export default function Notify(options) {
    var position = options.position, config = options.config, handleClick = options.handleClick, otherConfig = __rest(options, ["position", "config", "handleClick"]);
    var configID = notificationEntity.receiveNotify(Object.assign({}, config, otherConfig), position);
    return configID;
}
/**
 * 用于消除 Notify ，传入 notifyID
 */
export function CancelNotify(id) {
    if (!HasValue(id))
        return console.warn('must to pass {id}!');
    return notificationEntity.closeTip(id);
}
var notifyDOM = setDOMById(notifyDOMId);
ReactDOM.render(React.createElement(Notification, { ref: function (e) { notificationEntity = e; } }), notifyDOM);
