import { Component } from 'react';
interface PopoverHelperState {
    relativeElem: HTMLElement;
    open: boolean;
    children: any;
}
export declare class PopoverWrapper extends Component<{}, PopoverHelperState> {
    constructor(props: any);
    closePopover(): void;
    close(): void;
    show(elem: HTMLElement, isShow: boolean, children: any, props: {}): void;
    render(): JSX.Element;
}
interface PopoverConstructorOptions {
    /** 是否设置 css position: fixed */
    fixed?: boolean;
    /** id */
    id?: string;
}
interface PopShowParams {
    elem?: HTMLElement | EventTarget;
    children?: any;
    open?: boolean;
    props?: {};
}
interface PopSetParams extends PopShowParams {
    open: boolean;
}
declare class PopoverEntity {
    id: any;
    idPrefix: string;
    prevProps: any;
    lifeTimer: any;
    popoverEntity: any;
    prevOptions: {};
    constructor(options?: PopoverConstructorOptions);
    savePopWrapper: (e: PopoverWrapper) => void;
    initDOM(props: any): void;
    show(options: PopShowParams): void;
    set(options: PopSetParams): void;
    close(): void;
    destroy: () => void;
    delayClose(timer?: number): void;
}
declare const GlobalPopover: PopoverEntity;
declare const Pop: PopoverEntity;
/**
 * 例子
 * GlobalPopover.setPopover({
 *   position, width = 400, onClose, elem, children, open, props = prevProps, id = 'topPopover'
 * })
 * id: 用于区分不同的 popover ，避免关闭错误
 */
export { Pop, GlobalPopover, PopoverEntity };
