import React, { PureComponent } from 'react';
import { PopoverEntity } from '../popover';
import { Color } from '../utils/props';
import { IconProps } from '../icon/icon';
export interface ToolTipProps extends IconProps {
    /** 提示的标题 */
    title?: any;
    /** 颜色 */
    color?: Color;
    /** 传入 children 的 classNames */
    classNames?: string[];
    /** 点击即关闭弹出曾 */
    clickToClose?: boolean;
    /** 包裹的组件 */
    component?: React.ElementType;
    /** 弹出的位置 */
    position?: 'bottom' | 'top' | 'right' | 'left';
}
/**
 * 提供简单的提示按钮
 *
 * @export
 * @class ToolTip
 * @extends {PureComponent}
 */
export default class ToolTip extends PureComponent<ToolTipProps> {
    static defaultProps: {
        position: string;
        classNames: never[];
    };
    Popover: PopoverEntity;
    constructor(props: any);
    componentWillUnmount: () => void;
    handleMouseEnter: (e: any) => void;
    handleMouseLeave: (e: any) => void;
    handleClick: (e: any) => void;
    render(): JSX.Element;
}
