export declare type PopoverPosition = 'top' | 'right' | 'left' | 'bottom';
export interface PositionReturn {
    position: PopoverPosition;
    top: number;
    left: number;
}
export interface GetFuncParams {
    offsetTop: any;
    offsetLeft: any;
    offsetWidth: any;
    offsetHeight: any;
    elemWidth: any;
    elemHeight: any;
    fromRight?: boolean;
}
/**
 * 计算最终的 top 和 left，并且根据浏览器可视边界判断最终结果
 */
export declare function getLeft(params: GetFuncParams): PositionReturn;
export declare function getRight(params: GetFuncParams): PositionReturn;
export declare function getTop(params: GetFuncParams): PositionReturn;
export declare function getBottom(params: GetFuncParams): PositionReturn;
