/* eslint-disable @typescript-eslint/no-use-before-define */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { getScreenWidth, getScreenHeight } from './screen';
var ScreenWidth = getScreenWidth();
var ScreenHeight = getScreenHeight();
var verticalOffset = 14;
var horizontalOffset = 4;
window.onresize = function () {
    ScreenWidth = getScreenWidth();
    ScreenHeight = getScreenHeight();
};
/**
 * 计算最终的 top 和 left，并且根据浏览器可视边界判断最终结果
 */
export function getLeft(params) {
    var offsetLeft = params.offsetLeft, elemWidth = params.elemWidth, offsetTop = params.offsetTop, fromRight = params.fromRight, offsetWidth = params.offsetWidth, offsetHeight = params.offsetHeight, elemHeight = params.elemHeight;
    var left = offsetLeft - elemWidth - 12;
    if (left - elemWidth <= 0 && !fromRight)
        return getRight(params);
    // if(left + elemWidth > ScreenWidth) left = ScreenWidth - elemWidth;
    return {
        top: offsetTop - horizontalOffset,
        position: 'left',
        left: left
    };
}
export function getRight(params) {
    var offsetLeft = params.offsetLeft, elemWidth = params.elemWidth, offsetTop = params.offsetTop, fromRight = params.fromRight, offsetWidth = params.offsetWidth, offsetHeight = params.offsetHeight, elemHeight = params.elemHeight;
    var left = offsetLeft + offsetWidth + 15;
    if (left + elemWidth >= ScreenWidth)
        return getLeft(__assign({}, params, { fromRight: true }));
    // if(left - elemWidth <= 0) left = ScreenWidth - elemWidth;
    return {
        top: offsetTop - horizontalOffset,
        position: 'right',
        left: left
    };
}
export function getTop(params) {
    var offsetLeft = params.offsetLeft, elemWidth = params.elemWidth, offsetTop = params.offsetTop, fromRight = params.fromRight, offsetWidth = params.offsetWidth, offsetHeight = params.offsetHeight, elemHeight = params.elemHeight;
    var top = offsetTop - elemHeight - offsetHeight / 2;
    if (top - elemHeight <= 0)
        return getBottom(params);
    return {
        top: top,
        position: 'top',
        left: offsetLeft - verticalOffset
    };
}
export function getBottom(params) {
    var offsetLeft = params.offsetLeft, elemWidth = params.elemWidth, offsetTop = params.offsetTop, fromRight = params.fromRight, offsetWidth = params.offsetWidth, offsetHeight = params.offsetHeight, elemHeight = params.elemHeight;
    var top = offsetTop + offsetHeight + offsetHeight / 2;
    if (top + elemHeight >= ScreenHeight)
        return getTop(params);
    return {
        top: top,
        position: 'bottom',
        left: offsetLeft - verticalOffset
    };
}
